part of dartcord;

/// A channel.
class Channel extends _SnowflakeEntity {
  /// The channel's type.
  String type;

  /// A timestamp for when the channel was created.
  DateTime createdAt;

  Channel._new(Client client, Map<String, dynamic> data, this.type)
      : super(client) {
    this.id = data['id'];
    this.createdAt = Util.getDate(this.id);

    client.channels[this.id] = this;
  }

  /// Deletes the channel.
  Future<Null> delete() async {
    await this._client._http.send('DELETE', _DiscordEndpoints.channel(this.id));
    return null;
  }
}
